<?php
# -- BEGIN LICENSE BLOCK ----------------------------------
#
# This file is part of ePUBmaker, a plugin for Dotclear 2.
# 
# Copyright (c) 2012 Osku and contributors
# Licensed under the GPL version 2.0 license.
# See LICENSE file or
# http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#
# -- END LICENSE BLOCK ------------------------------------
if (!defined('DC_CONTEXT_ADMIN')) { return; }

$icon = 'index.php?pf=ePUBmaker/icon.png';

// superadmin or admin :
$permission = $core->auth->check('admin',$core->blog->id);

$_menu['Plugins']->addItem(__('ePUB maker'),
	'plugin.php?p=ePUBmaker',
	$icon,
	preg_match('/plugin.php\?p=ePUBmaker(.*)?$/',$_SERVER['REQUEST_URI']),
	$permission
);

$flag = $core->blog->settings->epubmaker->flag;

if ($flag) {
	//$core->auth->setPermissionType('epubmaker',__('create ePUB'));

	if ($core->auth->check('contentadmin,usage',$core->blog->id)
	&& $core->auth->check('media,media_item',$core->blog->id)) {
		$core->addBehavior('adminPostsActionsCombo',array('epubmakerBehaviors','adminPostsActionsCombo'));
		$core->addBehavior('adminPostsActions',array('epubmakerBehaviors','adminPostsActions'));
		$core->addBehavior('adminPostsActionsContent',array('epubmakerBehaviors','adminPostsActionsContent'));
		$core->addBehavior('adminPagesActionsCombo',array('epubmakerBehaviors','adminPostsActionsCombo'));
		$core->addBehavior('adminPagesActions',array('epubmakerBehaviors','adminPostsActions'));
		$core->addBehavior('adminPagesActionsContent',array('epubmakerBehaviors','adminPostsActionsContent'));
	}
}

class epubmakerBehaviors
{
	public static function adminPostsActionsCombo($args)
	{
		$args[0][__('eBook')] = array(__('Create ePUB') => 'epub');
	}
	
	public static function adminPostsActionsContent($core,$action,$hidden_fields,$form_uri="posts_actions.php")
	{
		if ($action == 'epub')
		{
			echo
			'<h2><span class="page-title">'.__('ePUB creation').'</span></h2>'.
			'<form action="'.$form_uri.'" method="post">'.
			'<p><label class="required" for="epub_filename"><abbr title="'.__('Required field').'">*</abbr> '.__('Filename:').' '.
			form::field('epub_filename',40,255).
			'</label></p> 
			<p class="form-note warn">'.__('File extension (<code>.epub</code>) is automatically added.').'</p>'.
			'<p><label for="epub_title">'.__('Title:').' '.
			form::field('epub_title',40,255).
			'</label></p> '.
			'<p class="form-note">'.__('Leave empty to use blog name').'</p>'.
			'<div class="p"><label class="area" for="epub_subject">'.__('Subject:').' </label>'.
			form::textarea('epub_subject',80,25,'','maximal').
			'</div> 
			<p class="form-note">'.__('Leave empty to use blog description').'</p>'.
			$hidden_fields.
			$core->formNonce().
			form::hidden(array('action'),'epub').
			form::hidden(array('sortby'),$_POST['sortby']).
			form::hidden(array('order'),$_POST['order']).
			'<p><input type="submit" value="'.__('Create').'" /></p>'.
			'</form>';
		}
	}
	
	public static function adminPostsActions($core,$posts,$action,$redir)
	{
		if ($action == 'epub' && isset($_POST['epub_filename'])&& isset($_POST['epub_title']) && isset($_POST['epub_subject']))
		{
			
			try
			{
				ePUBtools::load();
				$core->ePUBmaker->createEPUB(
					$posts,
					$_POST['epub_title'],
					$_POST['epub_subject'],
					$_POST['epub_filename'],
                    $_POST['sortby'],
                    $_POST['order']
				);
				//$redir = 'plugin.php?p=ePUBmaker&msg=new';
				$redir = 'media.php?popup=0&post_id=&d'.rawurlencode($core->blog->settings->epubmaker->repo);
				
				ePUBtools::unload();
				http::redirect($redir);
			}
			catch (Exception $e)
			{
				$core->error->add($e->getMessage());
			}
		}
	}
}
?>